#ifndef METABALL
#define METABALL

#include "include.h"

#define QUAD(x) ((x)*(x))
#define CHANGE(x) (1 + (x) - (rand() % 1000) * (x) / 1000)

#define THREADS 2

using namespace std;

class Ball
{
    public:
    double x, y, dx, dy, w, dw, brake, weight;

    Ball(int x, int y, double dx = 0, double dy = 0, double width = 250000, double dw = 0, double brake = 1, double weight = 10);
    void Update(Ball* b);
    void DoUpdate(int width, int height);
    double Distance(double x, double y);
};


class MetaBall
{
    public:
    BITMAP* bmp;
    int step;
    int buffer[WIDTH][HEIGHT];
    list<Ball*> ball;
    list<Ball*>::iterator it;
    list<Ball*>::iterator it2;
    int width, height;

    MetaBall(int width, int height);
    ~MetaBall();
    void MetaBall::Update();
    void MetaBall::Draw(BITMAP* dest, int x, int y);
    void BaseUpdate();
    void UpdateEx(int start, int end);
    void UpdateAsync();
    //DWORD WINAPI UpdateThread(LPVOID lpdwThreadParam);
};

class Pack
{
    public:
    Pack(MetaBall* mb, int i);
    MetaBall* mb;
    int i;
};

unsigned __stdcall UpdateThread(void* var);
#endif
