#include <allegro.h>
#include "include.h"
#include "MetaBall.h"

int main()
{
	allegro_init();
	install_keyboard();

	//Achtung: Die Farbtiefe muss auch in der _putpixel-Funktion (MetaBall.cpp) gendert werden
	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, WIDTH, HEIGHT, 0, 0);

	BITMAP* buffer = create_bitmap(SCREEN_W, SCREEN_H);

	MetaBall* mb = new MetaBall(SCREEN_W, SCREEN_H);
	mb->ball.push_back(new Ball(300,150,10,0,1,2500,.99,50));
	mb->ball.push_back(new Ball(150,300,0,0,1,1000,.99,20));
	mb->ball.push_back(new Ball(400,250,0,0,1,1000,.99,20));
	mb->ball.push_back(new Ball(100,150,0,0,1,1000,.99,20));

	long start, end;

    while(!key[KEY_ESC])
    {
       start = clock();
	   mb->UpdateAsync();
	   mb->Draw(buffer,0,0);
	   if(start != (end = clock()))
	       textprintf_ex(buffer, font, 0, 0, makecol(255,255,255), -1, "Fps: %d", (int)(1 / ((double)(end - start) / CLOCKS_PER_SEC)));

	   draw_sprite(screen, buffer, 0, 0);
    }

    destroy_bitmap(buffer);
    delete mb;

	return 0;
}
END_OF_MAIN();
